#include "stdafx.h"
#include "BankAccount.h"
#include <iostream>
#include <sstream>

using namespace std;

BankAccount::BankAccount(const string & name)
{
	accountHolder = name;
	currentBalance = 0;
	feesPayable = 0;
	tranAmount = 0;
}

void BankAccount::Deposit(double amount)
{
	feesPayable += FEE_PAYABLE;
	currentBalance += amount;
	AddTransaction(amount, currentBalance, "[D]");
}

void BankAccount::Withdraw(double amount)
{
	if (amount > currentBalance)
	{
		cout << "Insufficient funds!" << endl;
	}
	else
	{
		feesPayable += FEE_PAYABLE;
		currentBalance -= amount;
		AddTransaction(amount, currentBalance, "[W]");
	}
}

string BankAccount::GetAccountHolder() const
{
	return accountHolder;
}

double BankAccount::GetBalance() const
{
	return currentBalance;
}

double BankAccount::GetFeesPayable() const
{
	return feesPayable;
}

void BankAccount::AddTransaction(double amount, double balance, const string & type)
{
	stringstream oss;
	oss << type << " " << amount << "\tNew balance: " << currentBalance;

	if (tranAmount == TRAN_SIZE)
	{	
		RemoveTransaction();
	}
	tranList[tranAmount] = oss.str();
	tranAmount++;
}

void BankAccount::RemoveTransaction()
{
	if (tranAmount != 0)
	{	
		tranList[0] = "";
		for (int i=0;i<TRAN_SIZE-1;i++)
		{
			tranList[i] = tranList[i+1];
		}
		tranList[tranAmount-1] = "";
		tranAmount--;
	}
}

int BankAccount::GetTranAmount() const
{
	return tranAmount;
}

void BankAccount::SetTranAmount(int amount)
{
	tranAmount = amount;
}

void BankAccount::PrintTransactions() const
{
	cout << endl << "Transactions: " << endl;
	for (int i = 0; i < tranAmount; i++)
	{
		cout << tranList[i] << endl;
	}
}
