#pragma once

#include <string>
using namespace std;

#define FEE_PAYABLE 2
#define TRAN_SIZE 10

class BankAccount
{
public:
	// Public interface.
	BankAccount(const string & name);
	void Deposit(double amount);
	void Withdraw(double amount);
	string GetAccountHolder() const;
	double GetBalance() const;
	double GetFeesPayable() const;
	int GetTranAmount() const;
	void SetTranAmount(int amount);
	void PrintTransactions() const;

private:
	// Helper functions.
	void AddTransaction(double amount, double balance, const string & type);
	void RemoveTransaction();

private:
	// State.
	string accountHolder;
	double currentBalance;
	double feesPayable;
	int tranAmount;
	string tranList[TRAN_SIZE];
};